﻿using UnityEngine;
using System.Collections;

public class CameraZoom : MonoBehaviour
{
	private float m_cameraMinSize;
	private float m_cameraMaxSize;
	private float m_cameraSaveSize;

	void Start ()
	{
		m_cameraMinSize = 2f;
		m_cameraMaxSize = 6f;
		m_cameraSaveSize = Camera.main.orthographicSize;
	}
	
	public void ZoomIn()
	{
		m_cameraSaveSize = Mathf.Clamp(m_cameraSaveSize - 0.5f, m_cameraMinSize, m_cameraMaxSize);
		StartCoroutine(Zoom(-0.025f));
	}

	public void ZoomOut()
	{
		m_cameraSaveSize = Mathf.Clamp(m_cameraSaveSize + 0.5f, m_cameraMinSize, m_cameraMaxSize);
		StartCoroutine(Zoom(0.025f));
	}

	IEnumerator Zoom(float _step)
	{
		while(Mathf.Abs(Camera.main.orthographicSize - m_cameraSaveSize) >= 0.05f)
		{
			yield return new WaitForSeconds(0.005f);
			Camera.main.orthographicSize += _step;
		}

		Camera.main.orthographicSize = m_cameraSaveSize;
	}
}